def greet = { name -> println "hello $delegate" }

greet.delegate = 'Joe'
greet()
greet.delegate = 'Sara'
greet()

//changing an object is not a good idea
//can be error prone when the closure is run from
//different context in say multithreading

def greetClone = greet.clone()
greetClone.delegate = 'Joe'
greetClone()

'Jane'.with greet
//clones the given closure, sets delegate, and calls


